import java.awt.*;
import java.awt.event.*;

class Calculadora extends Frame
{  
    private Label  Display = new Label  ("", Label.RIGHT);

    private Button B0      = new Button ("0"),
                   B1      = new Button ("1"),
                   B2      = new Button ("2"),
                   B3      = new Button ("3"),
                   B4      = new Button ("4"),
                   B5      = new Button ("5"),
                   B6      = new Button ("6"),
                   B7      = new Button ("7"),
                   B8      = new Button ("8"),
                   B9      = new Button ("9"),
                   BA      = new Button ("+"),
                   BS      = new Button ("-"),
                   BM      = new Button ("*"),
                   BD      = new Button ("/"),
                   BI      = new Button ("="),
                   BL      = new Button ("C");

    private boolean Primeiro = true;

    private double  Operando1;
    private char    Operador = ' ';

    private void TrateClickEmBotaoNumerico (char N)
    {
        if (this.Primeiro)
        {
            this.Display.setText ("" + N);
            this.Primeiro = false;
        }
        else
            this.Display.setText (this.Display.getText () + N);
    }

    private void TrateClickEmBotaoDeOperacao (char O)
    {
        if (!this.Display.getText ().equals (""))
        {
            this.TrateClickNoBotaoIgual ();

            this.Operando1 = new Double
                            (this.Display.getText ())
                            .doubleValue ();

            this.Operador = O;
        }
    }

    private void TrateClickNoBotaoIgual ()
    {
        if ((!(this.Display.getText ().equals (""))) && (this.Operador != ' '))
        {
            double Operando2 = new Double
                              (this.Display.getText ()).doubleValue (),

                   Resultado = 0;

            switch (this.Operador)
            {
                case '+':
                    Resultado = this.Operando1 + Operando2;
                    break;

                case '-':
                    Resultado = this.Operando1 - Operando2;
                    break;

                case '*':
                    Resultado = this.Operando1 * Operando2;
                    break;

                case '/':
                    Resultado = this.Operando1 / Operando2;
            }

            if (Math.round (Resultado) == Resultado)
                this.Display.setText ("" + Math.round (Resultado));
            else
                this.Display.setText ("" + Resultado);

            this.Operador = ' ';
        }

        this.Primeiro = true;
    }

    private void TrateClickNoBotaoDeLimpar ()
    {
        this.Display.setText ("");

        this.Operador = ' ';
        this.Primeiro = true;
    }

    private void TrateFechamentoDaJanela ()
    {
        System.exit (0);
    }

    public Calculadora ()
    {
        BorderLayout LayoutCalculadora = new BorderLayout ();

        this.setTitle ("Calculadora");
        this.setSize  (200, 200);
        this.setLayout (LayoutCalculadora);

        Panel      Botoes       = new Panel ();
        GridLayout LayoutBotoes = new GridLayout (4, 4);

        Botoes.setLayout (LayoutBotoes);

        Botoes.add (this.B7);
        Botoes.add (this.B8);
        Botoes.add (this.B9);
        Botoes.add (this.BA);
        Botoes.add (this.B4);
        Botoes.add (this.B5);
        Botoes.add (this.B6);
        Botoes.add (this.BS);
        Botoes.add (this.B1);
        Botoes.add (this.B2);
        Botoes.add (this.B3);
        Botoes.add (this.BM);
        Botoes.add (this.B0);
        Botoes.add (this.BI);
        Botoes.add (this.BL);
        Botoes.add (this.BD);

        this.add ("North",  this.Display);
        this.add ("Center", Botoes);

        this.B0.addMouseListener
        (
            new MouseAdapter ()
            {
                public void mouseReleased (MouseEvent e)
                {
                    TrateClickEmBotaoNumerico ('0');
                }
            }
        );

        this.B1.addMouseListener
        (
            new MouseAdapter ()
            {
                public void mouseReleased (MouseEvent e)
                {
                    TrateClickEmBotaoNumerico ('1');
                }
            }
        );

        this.B2.addMouseListener
        (
            new MouseAdapter ()
            {
                public void mouseReleased (MouseEvent e)
                {
                    TrateClickEmBotaoNumerico ('2');
                }
            }
        );

        this.B3.addMouseListener
        (
            new MouseAdapter ()
            {
                public void mouseReleased (MouseEvent e)
                {
                    TrateClickEmBotaoNumerico ('3');
                }
            }
        );

        this.B4.addMouseListener
        (
            new MouseAdapter ()
            {
                public void mouseReleased (MouseEvent e)
                {
                    TrateClickEmBotaoNumerico ('4');
                }
            }
        );

        this.B5.addMouseListener
        (
            new MouseAdapter ()
            {
                public void mouseReleased (MouseEvent e)
                {
                    TrateClickEmBotaoNumerico ('5');
                }
            }
        );

        this.B6.addMouseListener
        (
            new MouseAdapter ()
            {
                public void mouseReleased (MouseEvent e)
                {
                    TrateClickEmBotaoNumerico ('6');
                }
            }
        );

        this.B7.addMouseListener
        (
            new MouseAdapter ()
            {
                public void mouseReleased (MouseEvent e)
                {
                    TrateClickEmBotaoNumerico ('7');
                }
            }
        );

        this.B8.addMouseListener
        (
            new MouseAdapter ()
            {
                public void mouseReleased (MouseEvent e)
                {
                    TrateClickEmBotaoNumerico ('8');
                }
            }
        );

        this.B9.addMouseListener
        (
            new MouseAdapter ()
            {
                public void mouseReleased (MouseEvent e)
                {
                    TrateClickEmBotaoNumerico ('9');
                }
            }
        );

        this.BA.addMouseListener
        (
            new MouseAdapter ()
            {
                public void mouseReleased (MouseEvent e)
                {
                    TrateClickEmBotaoDeOperacao ('+');
                }
            }
        );

        this.BS.addMouseListener
        (
            new MouseAdapter ()
            {
                public void mouseReleased (MouseEvent e)
                {
                    TrateClickEmBotaoDeOperacao ('-');
                }
            }
        );

        this.BM.addMouseListener
        (
            new MouseAdapter ()
            {
                public void mouseReleased (MouseEvent e)
                {
                    TrateClickEmBotaoDeOperacao ('*');
                }
            }
        );

        this.BD.addMouseListener
        (
            new MouseAdapter ()
            {
                public void mouseReleased (MouseEvent e)
                {
                    TrateClickEmBotaoDeOperacao ('/');
                }
            }
        );

        this.BI.addMouseListener
        (
            new MouseAdapter ()
            {
                public void mouseReleased (MouseEvent e)
                {
                    TrateClickNoBotaoIgual ();
                }
            }
        );

        this.BL.addMouseListener
        (
            new MouseAdapter ()
            {
                public void mouseReleased (MouseEvent e)
                {
                    TrateClickNoBotaoDeLimpar ();
                }
            }
        );

        this.addWindowListener
        (
            new WindowAdapter ()
            {
                public void windowClosing (WindowEvent e)
                {
                    TrateFechamentoDaJanela ();
                }
            }
         );

        this.show ();                
    }
}