import java.awt.*;
import java.awt.event.*;

class Calculadora extends Frame
{  
    private Label  Display = new Label ("", Label.RIGHT);

    private Button B0      = new Button ("0"),
                   B1      = new Button ("1"),
                   B2      = new Button ("2"),
                   B3      = new Button ("3"),
                   B4      = new Button ("4"),
                   B5      = new Button ("5"),
                   B6      = new Button ("6"),
                   B7      = new Button ("7"),
                   B8      = new Button ("8"),
                   B9      = new Button ("9"),
                   BA      = new Button ("+"),
                   BS      = new Button ("-"),
                   BM      = new Button ("*"),
                   BD      = new Button ("/"),
                   BI      = new Button ("="),
                   BL      = new Button ("C");

    private boolean Primeiro = true;

    private double Operando1;
    private char   Operador = ' ';

    protected class TratadorDeClicks extends MouseAdapter
    {
        private void TrateClickEmBotaoNumerico (char N)
        {
            if (Primeiro)
            {
                Display.setText ("" + N);
                Primeiro = false;
            }
            else
                Display.setText (Display.getText () + N);
        }

        private void TrateClickEmBotaoDeOperacao (char O)
        {
            if (!Display.getText ().equals (""))
            {
                this.TrateClickNoBotaoIgual ();

                Operando1 = new Double
                           (Display.getText ())
                           .doubleValue ();

                Operador  = O;
            }
        }

        private void TrateClickNoBotaoIgual ()
        {
            if ((!(Display.getText ().equals (""))) && (Operador != ' '))
            {
                double Operando2 = new Double
                                  (Display.getText ()).doubleValue (),

                       Resultado = 0;

                switch (Operador)
                {
                    case '+':
                        Resultado = Operando1 + Operando2;
                        break;

                    case '-':
                        Resultado = Operando1 - Operando2;
                        break;

                    case '*':
                        Resultado = Operando1 * Operando2;
                        break;

                    case '/':
                        Resultado = Operando1 / Operando2;
                }

                if (Math.round (Resultado) == Resultado)
                    Display.setText ("" + Math.round (Resultado));
                else
                    Display.setText ("" + Resultado);

                Operador = ' ';
            }

            Primeiro = true;
        }

        private void TrateClickNoBotaoDeLimpar ()
        {
            Display.setText ("");

            Operador = ' ';
            Primeiro = true;
        }

        public void mouseReleased (MouseEvent e)
        {
            if      (e.getComponent() == B0)
                this.TrateClickEmBotaoNumerico ('0');
            else if (e.getComponent() == B1)
                this.TrateClickEmBotaoNumerico ('1');
            else if (e.getComponent() == B2)
                this.TrateClickEmBotaoNumerico ('2');
            else if (e.getComponent() == B3)
                this.TrateClickEmBotaoNumerico ('3');
            else if (e.getComponent() == B4)
                this.TrateClickEmBotaoNumerico ('4');
            else if (e.getComponent() == B5)
                this.TrateClickEmBotaoNumerico ('5');
            else if (e.getComponent() == B6)
                this.TrateClickEmBotaoNumerico ('6');
            else if (e.getComponent() == B7)
                this.TrateClickEmBotaoNumerico ('7');
            else if (e.getComponent() == B8)
                this.TrateClickEmBotaoNumerico ('8');
            else if (e.getComponent() == B9)
                this.TrateClickEmBotaoNumerico ('9');

            else if (e.getComponent() == BA)
                this.TrateClickEmBotaoDeOperacao ('+');
            else if (e.getComponent() == BS)
                this.TrateClickEmBotaoDeOperacao ('-');
            else if (e.getComponent() == BM)
                this.TrateClickEmBotaoDeOperacao ('*');
            else if (e.getComponent() == BD)
                this.TrateClickEmBotaoDeOperacao ('/');

            else if (e.getComponent() == BI)
                this.TrateClickNoBotaoIgual ();
            else if (e.getComponent() == BL)
                this.TrateClickNoBotaoDeLimpar ();
        }
    }

    protected class TratadorDeFechamento extends WindowAdapter
    {
        public void windowClosing (WindowEvent e)
        {
            System.exit (0);
        }
    }

    public Calculadora ()
    {
        BorderLayout LayoutCalculadora = new BorderLayout ();

        this.setTitle ("Calculadora");
        this.setSize  (200, 200);
        this.setLayout (LayoutCalculadora);

        Panel      Botoes       = new Panel ();
        GridLayout LayoutBotoes = new GridLayout (4, 4);

        Botoes.setLayout (LayoutBotoes);

        Botoes.add (this.B7);
        Botoes.add (this.B8);
        Botoes.add (this.B9);
        Botoes.add (this.BA);
        Botoes.add (this.B4);
        Botoes.add (this.B5);
        Botoes.add (this.B6);
        Botoes.add (this.BS);
        Botoes.add (this.B1);
        Botoes.add (this.B2);
        Botoes.add (this.B3);
        Botoes.add (this.BM);
        Botoes.add (this.B0);
        Botoes.add (this.BI);
        Botoes.add (this.BL);
        Botoes.add (this.BD);

        this.add ("North",  this.Display);
        this.add ("Center", Botoes);

        TratadorDeClicks TC_Calculadora;
        TC_Calculadora = new TratadorDeClicks ();

        this.B0.addMouseListener (TC_Calculadora);
        this.B1.addMouseListener (TC_Calculadora);
        this.B2.addMouseListener (TC_Calculadora);
        this.B3.addMouseListener (TC_Calculadora);
        this.B4.addMouseListener (TC_Calculadora);
        this.B5.addMouseListener (TC_Calculadora);
        this.B6.addMouseListener (TC_Calculadora);
        this.B7.addMouseListener (TC_Calculadora);
        this.B8.addMouseListener (TC_Calculadora);
        this.B9.addMouseListener (TC_Calculadora);

        this.BA.addMouseListener (TC_Calculadora);
        this.BS.addMouseListener (TC_Calculadora);
        this.BM.addMouseListener (TC_Calculadora);
        this.BD.addMouseListener (TC_Calculadora);

        this.BI.addMouseListener (TC_Calculadora);
        this.BL.addMouseListener (TC_Calculadora);

        TratadorDeFechamento TF_Calculadora;
        TF_Calculadora = new TratadorDeFechamento ();

        this.addWindowListener (TF_Calculadora);

        this.show ();                
    }
}