import java.awt.*;
import java.awt.event.*;

class Calculadora extends    Frame
                  implements MouseListener,
                             WindowListener
{  
    private Label  Display = new Label ("", Label.RIGHT);

    private Button B0      = new Button ("0"),
                   B1      = new Button ("1"),
                   B2      = new Button ("2"),
                   B3      = new Button ("3"),
                   B4      = new Button ("4"),
                   B5      = new Button ("5"),
                   B6      = new Button ("6"),
                   B7      = new Button ("7"),
                   B8      = new Button ("8"),
                   B9      = new Button ("9"),
                   BA      = new Button ("+"),
                   BS      = new Button ("-"),
                   BM      = new Button ("*"),
                   BD      = new Button ("/"),
                   BI      = new Button ("="),
                   BL      = new Button ("C");

    private boolean Primeiro = true;

    private double  Operando1;
    private char    Operador = ' ';

    private void TrateClickEmBotaoNumerico (char N)
    {
        if (this.Primeiro)
        {
            this.Display.setText ("" + N);
            this.Primeiro = false;
        }
        else
            this.Display.setText (this.Display.getText () + N);
    }

    private void TrateClickEmBotaoDeOperacao (char O)
    {
        if (!this.Display.getText ().equals (""))
        {
            this.TrateClickNoBotaoIgual ();

            this.Operando1 = new Double
                            (this.Display.getText ())
                            .doubleValue ();

            this.Operador = O;
        }
    }

    private void TrateClickNoBotaoIgual ()
    {
        if ((!(this.Display.getText ().equals (""))) && (this.Operador != ' '))
        {
            double Operando2 = new Double
                              (this.Display.getText ()).doubleValue (),

                   Resultado = 0;

            switch (this.Operador)
            {
                case '+':
                    Resultado = this.Operando1 + Operando2;
                    break;

                case '-':
                    Resultado = this.Operando1 - Operando2;
                    break;

                case '*':
                    Resultado = this.Operando1 * Operando2;
                    break;

                case '/':
                    Resultado = this.Operando1 / Operando2;
            }

            if (Math.round (Resultado) == Resultado)
                this.Display.setText ("" + Math.round (Resultado));
            else
                this.Display.setText ("" + Resultado);

            this.Operador = ' ';
        }

        this.Primeiro = true;
    }

    private void TrateClickNoBotaoDeLimpar ()
    {
        this.Display.setText ("");

        this.Operador = ' ';
        this.Primeiro = true;
    }

    public Calculadora ()
    {
        BorderLayout LayoutCalculadora = new BorderLayout ();

        this.setTitle ("Calculadora");
        this.setSize  (200, 200);
        this.setLayout (LayoutCalculadora);

        Panel      Botoes       = new Panel ();
        GridLayout LayoutBotoes = new GridLayout (4, 4);

        Botoes.setLayout (LayoutBotoes);

        Botoes.add (this.B7);
        Botoes.add (this.B8);
        Botoes.add (this.B9);
        Botoes.add (this.BA);
        Botoes.add (this.B4);
        Botoes.add (this.B5);
        Botoes.add (this.B6);
        Botoes.add (this.BS);
        Botoes.add (this.B1);
        Botoes.add (this.B2);
        Botoes.add (this.B3);
        Botoes.add (this.BM);
        Botoes.add (this.B0);
        Botoes.add (this.BI);
        Botoes.add (this.BL);
        Botoes.add (this.BD);

        this.add ("North",  this.Display);
        this.add ("Center", Botoes);

        this.B0.addMouseListener (this);
        this.B1.addMouseListener (this);
        this.B2.addMouseListener (this);
        this.B3.addMouseListener (this);
        this.B4.addMouseListener (this);
        this.B5.addMouseListener (this);
        this.B6.addMouseListener (this);
        this.B7.addMouseListener (this);
        this.B8.addMouseListener (this);
        this.B9.addMouseListener (this);

        this.BA.addMouseListener (this);
        this.BS.addMouseListener (this);
        this.BM.addMouseListener (this);
        this.BD.addMouseListener (this);

        this.BI.addMouseListener (this);
        this.BL.addMouseListener (this);

        this.addWindowListener (this);

        this.show ();                
    }

    public void mouseReleased (MouseEvent e)
    {
        if      (e.getComponent() == this.B0)
            this.TrateClickEmBotaoNumerico ('0');
        else if (e.getComponent() == this.B1)
            this.TrateClickEmBotaoNumerico ('1');
        else if (e.getComponent() == this.B2)
            this.TrateClickEmBotaoNumerico ('2');
        else if (e.getComponent() == this.B3)
            this.TrateClickEmBotaoNumerico ('3');
        else if (e.getComponent() == this.B4)
            this.TrateClickEmBotaoNumerico ('4');
        else if (e.getComponent() == this.B5)
            this.TrateClickEmBotaoNumerico ('5');
        else if (e.getComponent() == this.B6)
            this.TrateClickEmBotaoNumerico ('6');
        else if (e.getComponent() == this.B7)
            this.TrateClickEmBotaoNumerico ('7');
        else if (e.getComponent() == this.B8)
            this.TrateClickEmBotaoNumerico ('8');
        else if (e.getComponent() == this.B9)
            this.TrateClickEmBotaoNumerico ('9');

        else if (e.getComponent() == this.BA)
            this.TrateClickEmBotaoDeOperacao ('+');
        else if (e.getComponent() == this.BS)
            this.TrateClickEmBotaoDeOperacao ('-');
        else if (e.getComponent() == this.BM)
            this.TrateClickEmBotaoDeOperacao ('*');
        else if (e.getComponent() == this.BD)
            this.TrateClickEmBotaoDeOperacao ('/');

        else if (e.getComponent() == this.BI)
            this.TrateClickNoBotaoIgual ();
        else if (e.getComponent() == this.BL)
            this.TrateClickNoBotaoDeLimpar ();
    }

    public void mousePressed (MouseEvent e)
    {}

    public void mouseClicked (MouseEvent e)
    {}

    public void mouseEntered (MouseEvent e)
    {}

    public void mouseExited (MouseEvent e)
    {}

    public void windowClosing (WindowEvent e)
    {
        System.exit (0);
    }

    public void windowOpened (WindowEvent e)
    {}

    public void windowClosed (WindowEvent e)
    {}

    public void windowActivated (WindowEvent e)
    {}

    public void windowDeactivated (WindowEvent e)
    {}

    public void windowIconified (WindowEvent e)
    {}

    public void windowDeiconified (WindowEvent e)
    {}
}