import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import BibAgenda.*;

class TesteDeAgenda
{
    public static void main (String Args [])
    {
        BufferedReader Entrada = new BufferedReader
                                (new InputStreamReader
                                (System.in));

        Agenda agenda = null;

        for (;;)
        {
            System.out.println ();

            System.out.print ("Capacidade desejada para a Agenda: ");
            try
            {
                int C  = Integer.parseInt (Entrada.readLine ());
                agenda = new Agenda (C);
            }
            catch (IOException E)
            {}
            catch (NumberFormatException E)
            {
                System.err.println ("Nao foi digitado um numero inteiro");
                System.err.println ();
                continue;
            }
            catch (ExcecaoDeAgenda E)
            {
                System.err.println (E.getMessage());
                System.err.println ();
                continue;
            }

            break;
        }

        System.out.println ();

        String Nome = null, Telefone = null;

        char Opcao = ' ';

        do
        {
            System.out.println ();

            System.out.print ("Digite sua Opcao (" +
                              "I=Incluir/" +
                              "C=Consultar/" +
                              "L=Listar/" +
                              "E=Excluir/" +
                              "S=Sair)" +
                              ": ");

            try
            {
                Opcao = (Entrada.readLine ()).charAt (0);
            }
            catch (IOException E)
            {}

    Opcoes: switch (Opcao)
            {
                case 'i':
                case 'I':
                    if (agenda.quantosContatos () == agenda.capacidade ())
                    {
                        System.err.println
                        (ExcecaoDeAgenda.Mensagem[ExcecaoDeAgenda.AGENDA_CHEIA]);
                        System.err.println ();
                        break;
                    }

                    try
                    {
                        System.out.print ("Nome....: ");
                        Nome = Entrada.readLine ();
                    }
                    catch (IOException E)
                    {}

                    if (agenda.haRegistroDoContato (Nome))
                    {
                        System.err.println
                        (ExcecaoDeAgenda.Mensagem[ExcecaoDeAgenda.NOME_JA_REGISTRADO]);
                        System.err.println ();
                        break;
                    }

                    try
                    {
                        System.out.print ("Telefone: ");
                        Telefone = Entrada.readLine ();
                    }
                    catch (IOException E)
                    {}

                    try
                    {
                        agenda.registreOContato (Nome, Telefone);
                    }
                    catch (ExcecaoDeAgenda E)
                    {}

                    System.out.println ();
                    break;


                case 'c':
                case 'C':
                    if (agenda.quantosContatos () == 0)
                    {
                        System.err.println
                        (ExcecaoDeAgenda.Mensagem[ExcecaoDeAgenda.AGENDA_VAZIA]);
                        System.err.println ();
                        break;
                    }

                    try
                    {
                        System.out.print ("Nome....: ");
                        Nome = Entrada.readLine ();
                    }
                    catch (IOException E)
                    {}

                    try
                    {
                        Telefone = agenda.digaMeOTelefoneDe (Nome);
                    }
                    catch (ExcecaoDeAgenda E)
                    {
                        System.err.println
                        (ExcecaoDeAgenda.Mensagem[ExcecaoDeAgenda.NOME_INEXISTENTE]);
                        System.err.println ();
                        break;
                    }

                    System.out.println ("Telefone: " + Telefone);
                    System.out.println ();
                    break;


                case 'l':
                case 'L': 
                    String Tecla;

         Exibicao: for (int I = 0;; I++)
                    {
                        try
                        {
                            System.out.println ("Nome: " +
                                                agenda.digaMeONome (I) +
                                                " - Telefone: " +
                                                agenda.digaMeOTelefone (I));
                        }
                        catch (ExcecaoDeAgenda E)
                        {
                            switch (E.seuTipo ())
                            {
                                case ExcecaoDeAgenda.AGENDA_VAZIA:
                                    System.err.println (E.getMessage ());
                                    System.err.println ();
                                    break Opcoes;

                                case ExcecaoDeAgenda.NOME_FORA_DOS_LIMITES:
                                    break Exibicao;
                            }
                        }

                        if (I%23 == 22 && I < agenda.quantosContatos()-1)
                        {
                            System.out.println ();
                            System.out.print ("Tecle ENTER... ");

                            try
                            {
                                Tecla = Entrada.readLine ();
                            }
                            catch (IOException E)
                            {}

                            System.out.println ();
                        }
                    }

                    System.out.println ();
                    break;


                case 'e':
                case 'E':
                    if (agenda.quantosContatos () == 0)
                        System.err.println
                        (ExcecaoDeAgenda.Mensagem[ExcecaoDeAgenda.AGENDA_VAZIA]);

                    else
                    {
                          System.out.print ("Nome....: ");
                          try
                          {
                              Nome = Entrada.readLine ();
                          }
                          catch (IOException E)
                          {}

                          try
                          {
                              agenda.descarteContato (Nome);
                          }
                          catch (ExcecaoDeAgenda E)
                          {
                              // certamente sera
                              // ExcecaoDeAgenda.NOME_INEXISTENTE

                              System.err.println (E.getMessage ());
                          }
                    }

                    System.out.println ();
                    break;


                case 's':
                case 'S':
                    break;


                default :
                    System.err.println ("Opcao invalida");
                    System.err.println ();
            }
        }
        while ((Opcao != 's') && (Opcao != 'S'));
    }
}