import java.io.*;

class TudoMaiusculo
{
    public static void main (String Args [])
    {
        BufferedReader ArqEntrada = null;

        if (Args.length != 2)
        {
            System.err.println ();
            System.err.println ("USO CORRETO: " +
                                "java TudoMaiusculo ArqEntrada ArqSaida");
            return;
        }

        try
        {
            ArqEntrada = new BufferedReader (new FileReader (Args [0]));
        }
        catch (IOException E)
        {
            System.err.println ();
            System.err.println ("Nao foi possivel abrir o arquivo " +
                                Args [0] + "!");
            System.err.println ();
            return;
        }

        try
        {
            if (!ArqEntrada.ready ())
                return;
        } 
        catch (IOException E)
        {}

        File IdArqSaida = new File (Args [1]);

        if (IdArqSaida.exists ())
        {
            System.out.println ();

            System.out.print ("O arquivo " + Args [1] + " ja existe... ");
            System.out.print ("Deseja sobrescreve-lo (S/N)? ");

            BufferedReader Entrada = new BufferedReader
                                    (new InputStreamReader
                                    (System.in));
            String Resposta = null;

            try
            {
                Resposta = Entrada.readLine ().toUpperCase ();
            }
            catch (IOException E)
            {}

            if (!Resposta.equals ("S"))
            {
                System.out.println ("Programa terminado!");
                return;
            }
        }

        PrintStream ArqSaida = null;

        try
        {
            ArqSaida = new PrintStream (new FileOutputStream (Args [1]));

        }
        catch (IOException E)
        {
            System.err.println ();
            System.err.println ("Nao foi possivel abrir O arquivo " +
                                Args [1] + "!");
            System.err.println ();
            return;
        }

        for (;;)
        {
            String Linha = null;

            try
            {
                Linha = ArqEntrada.readLine ();            
            }
            catch (IOException E)
            {
                System.err.println ();
                System.err.println ("Nao foi possivel ler do arquivo " + 
                                    Args [0] + "!");
                System.err.println ();
                return;
            }

            Linha = Linha.toUpperCase ();

            ArqSaida.print (Linha);

            try
            {
                if (ArqEntrada.ready ())
                    ArqSaida.println ();
                else
                    break;
            }
            catch (IOException E)
            {}
        }      

        try
        {
            ArqEntrada.close ();
        }
        catch (IOException E)
        {
            System.err.println ();
            System.err.println ("Nao foi possivel fechar o arquivo " +
                                Args [0] + "!");
            System.err.println ();
            return;
        }

        ArqSaida.close ();
    }
}