package BibAgenda;

public class ExcecaoDeAgenda extends Exception 
{
    public static final int CAPACIDADE_INVALIDA   = 0,
                            AGENDA_CHEIA          = 1,
                            AGENDA_VAZIA          = 2,
                            NOME_INEXISTENTE      = 3,
                            NOME_JA_REGISTRADO    = 4,
                            FONE_FORA_DOS_LIMITES = 5,
                            NOME_FORA_DOS_LIMITES = 6,
                            EXCECAO_INVALIDA      = 7;

    private static final int MENOR_ID = CAPACIDADE_INVALIDA,
                             MAIOR_ID = NOME_FORA_DOS_LIMITES;

    public static final String Mensagem [] =
    {
         "Capacidade deve ser um numero natural positivo",
         "Esgotou-se a capacidade da agenda",
         "Nao ha contatos registrados na agenda",
         "O nome deste contato nao consta na agenda",
         "O nome deste contato ja consta na agenda",
         "So solicite telefones entre zero e a quantidade existente",
         "So solicite nomes entre zero e a quantidade existente",
         "Indicacao de excecao invalida"
    };


    private int Tipo;

    private ExcecaoDeAgenda (int T)
    {
        super (ExcecaoDeAgenda.Mensagem [T]);
        this.Tipo = T;
    }

    public static void indique (int T) throws ExcecaoDeAgenda
    {
        if (T<ExcecaoDeAgenda.MENOR_ID || T>ExcecaoDeAgenda.MAIOR_ID)
            throw new ExcecaoDeAgenda (ExcecaoDeAgenda.EXCECAO_INVALIDA);

        throw new ExcecaoDeAgenda (T);
        
    }

    public int seuTipo ()
    {
        return this.Tipo;
    }
}