package BibAgenda;

import java.io.Serializable;

public class Agenda implements Serializable
{
    private int QtosContatos = 0;

    private String  Nome     [],
                    Telefone [];

    private int ondeEsta (String N)
    {
        int Inicio = 0, Final = this.QtosContatos - 1, Onde;

        while (Inicio <= Final)
        {
            Onde = (Inicio + Final) / 2;

            int Comparacao = N.compareTo (this.Nome [Onde]);

            if (Comparacao == 0)
                return Onde;
            else
                if (Comparacao < 0)
                    Final = Onde - 1;
                else
                    Inicio = Onde + 1;
        }

        return -1;
    }

    private int ondeGuardar (String N)
    {
        int Inicio     = 0,
            Final      = this.QtosContatos - 1,
            Onde       = 0,
            Comparacao = -1;

        while (Inicio <= Final)
        {
            Onde       = (Inicio + Final) / 2;
            Comparacao = N.compareTo (this.Nome [Onde]);

            if (Comparacao == 0)
                return -1;
            else
                if (Comparacao < 0)
                    Final = Onde - 1;
                else
                    Inicio = Onde + 1;
        }

        return Comparacao < 0? Onde: Onde + 1;
    }

    public Agenda (int C) throws ExcecaoDeAgenda
    {
        if (C <= 0)
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.CAPACIDADE_INVALIDA);

        this.Nome     = new String [C];
        this.Telefone = new String [C];
    }

    public int capacidade ()
    {
        return this.Nome.length;
    }

    public int quantosContatos ()
    {
        return this.QtosContatos;
    }

    public boolean haRegistroDoContato (String N)
    {
        return this.ondeEsta (N) != -1;
    }

    public void registreOContato (String N, String T) throws ExcecaoDeAgenda
    {
        if (this.QtosContatos == this.Nome.length)
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.AGENDA_CHEIA);

        int Posicao = this.ondeGuardar (N);

        if (Posicao == -1)
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.NOME_JA_REGISTRADO);

        for (int I = this.QtosContatos - 1; I >= Posicao; I--)
        {
            this.Nome     [I+1] = this.Nome     [I];
            this.Telefone [I+1] = this.Telefone [I];
        }

        this.Nome     [Posicao] = N;
        this.Telefone [Posicao] = T;

        this.QtosContatos++;
    }    

    public String digaMeONome (int P) throws ExcecaoDeAgenda
    {
        if (this.QtosContatos == 0)
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.AGENDA_VAZIA);

        if (P < 0 || P >= this.QtosContatos)
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.NOME_FORA_DOS_LIMITES);

        return this.Nome [P];
    }

    public String digaMeOTelefone (int P) throws ExcecaoDeAgenda
    {
        if (this.QtosContatos == 0)
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.AGENDA_VAZIA);

        if (P < 0 || P >= this.QtosContatos)
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.FONE_FORA_DOS_LIMITES);

        return this.Telefone [P];
    }

    public String digaMeOTelefoneDe (String N) throws ExcecaoDeAgenda
    {
        if (this.QtosContatos == 0)
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.AGENDA_VAZIA);

        int Posicao = this.ondeEsta (N);

        if (Posicao == -1)
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.NOME_INEXISTENTE);

        return this.Telefone [Posicao];
    }

    public void descarteContato (String N) throws ExcecaoDeAgenda
    {
        if (this.QtosContatos == 0)
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.AGENDA_VAZIA);

        int Posicao = this.ondeEsta (N);

        if (Posicao == -1)
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.NOME_INEXISTENTE);

        int I;

        for (I = Posicao; I < this.QtosContatos - 1; I++)
        {
            this.Nome     [I] = this.Nome     [I+1];
            this.Telefone [I] = this.Telefone [I+1];
        }

        this.Nome     [I] = null;
        this.Telefone [I] = null;

        this.QtosContatos--;
    }    
}