package BibAgenda;

import java.sql.*;

public class Agenda
{
    private Connection Conexao;
    private Statement  Comando;
    private ResultSet  Resultado;

    public Agenda()  throws ExcecaoDeAgenda
    {
        try
        {
            Class.forName ("sun.jdbc.odbc.JdbcOdbcDriver");
        }
        catch(java.lang.ClassNotFoundException E)
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.IMPOSSIVEL_CARREGAR_DRIVER);
        }

        try
        {
            Conexao = DriverManager.getConnection
                      ("jdbc:odbc:ALIAS","USUARIO","SENHA");
        }
        catch(SQLException E)
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.IMPOSSIVEL_ESTABELECER_CONEXAO);
        }

        try
        {
            Comando = Conexao.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,
                                              ResultSet.CONCUR_READ_ONLY);
        }
        catch(SQLException E)
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.IMPOSSIVEL_CRIAR_COMANDO);
        }
    }

    public int quantosContatos () throws ExcecaoDeAgenda
    {
        try
        {
            Resultado = Comando.executeQuery
                        ("select count(*) as QtosContatos from Agenda");
        }
        catch (SQLException E)
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.IMPOSSIVEL_EXECUTAR_COMANDO);
        }

        try
        {
            Resultado.first ();
        }
        catch (SQLException E)
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.IMPOSSIVEL_POSICIONAR_EM_LINHA);
        }

        int R = 0;

        try
        {
            R = Resultado.getInt ("QtosContatos");
        }
        catch (SQLException E)
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.IMPOSSIVEL_RECUPERAR_COLUNA);
        }
        
        return R;
    }

    public boolean haRegistroDoContato (String N) throws ExcecaoDeAgenda
    {
        try
        {
            Resultado = Comando.executeQuery
                        ("Select count(*) as Qtd from Agenda where Nome = \'" +
                          N +
                         "\'");
        }
        catch (SQLException E)
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.IMPOSSIVEL_EXECUTAR_COMANDO);
        }

        try
        {
            Resultado.first ();
        }
        catch (SQLException E)
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.IMPOSSIVEL_POSICIONAR_EM_LINHA);
        }

        boolean R = false;

        try
        {
            R = Resultado.getInt ("Qtd") != 0;
        }
        catch (SQLException E)
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.IMPOSSIVEL_RECUPERAR_COLUNA);
        }
        
        return R;
    }

    public void registreOContato (String N, String T) throws ExcecaoDeAgenda
    {
        if (this.haRegistroDoContato (N))
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.NOME_JA_REGISTRADO);
        }

        try
        {
            Comando.executeUpdate
            ("Insert into Agenda (Nome, Telefone) values (\'"+N+"\',\'"+T+"\')");
        }
        catch(SQLException e)
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.IMPOSSIVEL_EXECUTAR_COMANDO);
        }
    }    

    public String digaMeNome (int P) throws ExcecaoDeAgenda
    {
        int QC = this.quantosContatos ();

        if (P < 0 || P >= QC)
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.NOME_FORA_DOS_LIMITES);
        }

        try
        {
            Resultado = Comando.executeQuery
                        ("select Nome from Agenda");
        }
        catch (SQLException E)
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.IMPOSSIVEL_EXECUTAR_COMANDO);
        }

        try
        {
            Resultado.absolute (P+1);
        }
        catch (SQLException E)
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.IMPOSSIVEL_POSICIONAR_EM_LINHA);
        }

        String R = null;

        try
        {
            R = Resultado.getString ("Nome");
        }
        catch (SQLException E)
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.IMPOSSIVEL_RECUPERAR_COLUNA);
        }

        return R;
    }

    public String digaMeTelefone (int P) throws ExcecaoDeAgenda
    {
        int QC = this.quantosContatos ();

        if (P < 0 || P >= this.quantosContatos ())
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.FONE_FORA_DOS_LIMITES);
        }

        try
        {
            Resultado = Comando.executeQuery
                        ("select Telefone from Agenda");
        }
        catch (SQLException E)
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.IMPOSSIVEL_EXECUTAR_COMANDO);
        }

        try
        {
            Resultado.absolute (P+1);
        }
        catch (SQLException E)
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.IMPOSSIVEL_POSICIONAR_EM_LINHA);
        }

        String R = null;

        try
        {
            R = Resultado.getString ("Telefone");
        }
        catch (SQLException E)
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.IMPOSSIVEL_RECUPERAR_COLUNA);
        }

        return R;
    }

    public String digaMeTelefoneDe (String N) throws ExcecaoDeAgenda
    {
        if (!this.haRegistroDoContato (N))
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.NOME_INEXISTENTE);
        }

        try
        {
            Resultado = Comando.executeQuery
                        ("select Telefone from Agenda where Nome = \'" +
                         N +
                         "\'");
        }
        catch (SQLException E)
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.IMPOSSIVEL_EXECUTAR_COMANDO);
        }

        try
        {
            Resultado.first ();
        }
        catch (SQLException E)
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.IMPOSSIVEL_POSICIONAR_EM_LINHA);
        }

        String R = null;

        try
        {
            R = Resultado.getString ("Telefone");
        }
        catch (SQLException E)
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.IMPOSSIVEL_RECUPERAR_COLUNA);
        }

        return R;
    }

    public void descarteContato (String N) throws ExcecaoDeAgenda
    {
        if (!this.haRegistroDoContato (N))
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.NOME_INEXISTENTE);
        }

        try
        {
            Comando.executeUpdate
            ("Delete from Agenda where Nome=\'" + N + "\'");
        }
        catch (SQLException E)
        {
            ExcecaoDeAgenda.indique (ExcecaoDeAgenda.IMPOSSIVEL_EXECUTAR_COMANDO);
        }
    }    
}