package BibAgenda;

public class ExcecaoDeAgenda extends RuntimeException 
{
    public static final int IMPOSSIVEL_CARREGAR_DRIVER     =  0,
                            IMPOSSIVEL_ESTABELECER_CONEXAO =  1,
                            IMPOSSIVEL_CRIAR_COMANDO       =  2,
                            IMPOSSIVEL_EXECUTAR_COMANDO    =  3,
                            IMPOSSIVEL_POSICIONAR_EM_LINHA =  4,
                            IMPOSSIVEL_RECUPERAR_COLUNA    =  5,
                            PROBLEMAS_DE_ACESSO_AO_BD      =  6,
                            NOME_INEXISTENTE               =  7,
                            NOME_JA_REGISTRADO             =  8,
                            FONE_FORA_DOS_LIMITES          =  9,
                            NOME_FORA_DOS_LIMITES          = 10,
                            EXCECAO_INVALIDA               = 11;

    private static final int MENOR_ID = IMPOSSIVEL_CARREGAR_DRIVER,
                             MAIOR_ID = NOME_FORA_DOS_LIMITES;

    public static final String Mensagem [] =
    {
         "Nao foi possivel carregar o driver de acesso ao BD",
         "Nao foi possivel estabelecer conexao com o SGBD",
         "Nao foi possivel preparar comando para o SGBD",
         "Nao foi possivel para o SGBD executar comando",
         "Nao foi possivel posicionar em uma linha",
         "Nao foi possivel recuperar uma coluna",
         "Ocorreram problemas de acesso ao BD",
         "O nome deste contato nao consta na agenda",
         "O nome deste contato ja consta na agenda",
         "So solicite telefones entre zero e a quantidade existente",
         "So solicite nomes entre zero e a quantidade existente",
         "Indicacao de excecao invalida"
    };


    private int Tipo;

    private ExcecaoDeAgenda (int T)
    {
        super (ExcecaoDeAgenda.Mensagem [T]);
        this.Tipo = T;
    }

    public static void indique (int T) throws ExcecaoDeAgenda
    {
        if (T<ExcecaoDeAgenda.MENOR_ID || T>ExcecaoDeAgenda.MAIOR_ID)
            throw new ExcecaoDeAgenda (ExcecaoDeAgenda.EXCECAO_INVALIDA);

        throw new ExcecaoDeAgenda (T);
    }

    public int seuTipo ()
    {
        return this.Tipo;
    }
}