import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import BibAgenda.*;

class TesteDeAgenda
{
    public static void main (String Args [])
    {
        BufferedReader Entrada = new BufferedReader
                                (new InputStreamReader
                                (System.in));

        Agenda agenda;

        try
        {
            agenda = new Agenda ();
        }
        catch (ExcecaoDeAgenda E)
        {
            System.err.print (E.getMessage ()+"\n\n");
            return;
        }

        char   Opcao = ' ';

        do
        {
            System.out.println ();

            System.out.print ("Digite sua Opcao (" +
                              "I=Incluir/" +
                              "C=Consultar/" +
                              "L=Listar/" +
                              "E=Excluir/" +
                              "S=Sair)" +
                              ": ");

            try
            {
                Opcao = (Entrada.readLine ()).charAt (0);
            }
            catch (IOException E)
            {}

            String Nome = null, Telefone = null;

            switch (Opcao)
            {
                case 'i':
                case 'I':
                    System.out.print ("Nome....: ");
                    try
                    {
                        Nome = Entrada.readLine ();
                    }
                    catch (IOException E)
                    {}

                    try
                    {
                        System.out.print ("Telefone: ");
                        Telefone = Entrada.readLine ();

                        agenda.registreOContato (Nome, Telefone);
                    }
                    catch (IOException E)
                    {}
                    catch (ExcecaoDeAgenda E)
                    {
                        System.err.print (E.getMessage ()+"\n\n");
                    }

                    System.out.println ();
                    break;


                case 'c':
                case 'C':
                    System.out.print ("Nome....: ");
                    try
                    {
                        Nome = Entrada.readLine ();
                    }
                    catch (IOException E)
                    {}

                    try
                    {
                        Telefone = agenda.digaMeTelefoneDe (Nome);
                    }
                    catch (ExcecaoDeAgenda E)
                    {
                        System.err.print (E.getMessage ()+"\n\n");
                    }

                    System.out.println ("Telefone: " +
                                        Telefone);

                    System.out.println ();
                    break;


                case 'l':
                case 'L': 
                    try
                    {
                        String Tecla;

                        for (int I = 0;
                             I < agenda.quantosContatos ();
                             I++)
                        {
                            System.out.println ("Nome: " +
                                                agenda.digaMeNome (I) +
                                                " - Telefone: " +
                                                agenda.digaMeTelefone (I));

                            if (I%23 == 22 && I < agenda.quantosContatos()-1)
                            {
                                System.out.println ();
                                System.out.print ("Tecle ENTER... ");
                                Tecla = Entrada.readLine ();
                                System.out.println ();
                            }
                        }
                    }
                    catch (IOException E)
                    {}
                    catch (ExcecaoDeAgenda E)
                    {
                        if (E.seuTipo () == ExcecaoDeAgenda.PROBLEMAS_DE_ACESSO_AO_BD)
                            System.err.print (E.getMessage ()+"\n\n");

                        // Nada e feito se
                        // E.seuTipo () == ExcecaoDeAgenda.NOME_FORA_DOS_LIMITES
                    }

                    System.out.println ();
                    break;


                case 'e':
                case 'E':
                    System.out.print ("Nome....: ");
                    try
                    {
                        Nome = Entrada.readLine ();
                    }
                    catch (IOException E)
                    {}

                    try
                    {
                        agenda.descarteContato (Nome);
                    }
                    catch (ExcecaoDeAgenda E)
                    {
                        System.err.print (E.getMessage ()+"\n\n");
                    }

                    System.out.println ();
                    break;


                case 's':
                case 'S':
                    break;


                default :
                    System.err.println ("Opcao invalida");
                    System.err.println ();
            }
        }
        while ((Opcao != 's') && (Opcao != 'S'));
    }
}