import java.awt.*;
import java.awt.event.*;
import java.util.Date;

class Calculadora extends    Frame
                  implements WindowListener,
                             MouseListener,
                             KeyListener
{  
    private Label  Display = new Label ("", Label.RIGHT);
    private Button Botao [];

    private boolean Primeiro = true;

    private double  Operando1;
    private char    Operador = ' ';

    private void TrateClickEmBotaoNumerico (char N)
    {
        if (this.Primeiro)
        {
            this.Display.setText ("" + N);
            this.Primeiro = false;
        }
        else
            this.Display.setText (this.Display.getText () + N);
    }

    private void TrateClickEmBotaoDeOperacao (char O)
    {
        if (!this.Display.getText ().equals (""))
        {
            this.TrateClickNoBotaoIgual ();

            this.Operando1 = new Double
                            (this.Display.getText ())
                            .doubleValue ();

            this.Operador = O;
        }
    }

    private void TrateClickNoBotaoIgual ()
    {
        if ((!(this.Display.getText ().equals (""))) && (this.Operador != ' '))
        {
            double Operando2 = new Double
                              (this.Display.getText ()).doubleValue (),

                   Resultado = 0;

            switch (this.Operador)
            {
                case '+':
                    Resultado = this.Operando1 + Operando2;
                    break;

                case '-':
                    Resultado = this.Operando1 - Operando2;
                    break;

                case '*':
                    Resultado = this.Operando1 * Operando2;
                    break;

                case '/':
                    Resultado = this.Operando1 / Operando2;
            }

            if (Math.round (Resultado) == Resultado)
                this.Display.setText ("" + Math.round (Resultado));
            else
                this.Display.setText ("" + Resultado);

            this.Operador = ' ';
        }

        this.Primeiro = true;
    }

    private void TrateClickNoBotaoDeLimpar ()
    {
        this.Display.setText ("");

        this.Operador = ' ';
        this.Primeiro = true;
    }

    public Calculadora ()
    {
        this.setTitle ("Calculadora");
        this.setSize  (200, 200);

        BorderLayout LayoutCalculadora = new BorderLayout ();
        this.setLayout (LayoutCalculadora);

        this.addWindowListener (this);

        Panel      Botoes       = new Panel ();
        GridLayout LayoutBotoes = new GridLayout (4, 4);

        Botoes.setLayout (LayoutBotoes);

        String Rotulo [] = {"7", "8", "9", "+",
                            "4", "5", "6", "-",
                            "1", "2", "3", "*",
                            "0", "=", "C", "/"};

        this.Botao = new Button [Rotulo.length];

        for (int I = 0; I < this.Botao.length; I++)
        {
            this.Botao [I] = new Button (Rotulo [I]);

            this.Botao [I].addMouseListener (this);
            this.Botao [I].addKeyListener   (this);

            Botoes.add (this.Botao [I]);
        }

        this.add ("North",  this.Display);
        this.add ("Center", Botoes);

        this.show ();                
    }

    public void windowClosing (WindowEvent e)
    {
        System.exit (0);
    }

    public void windowOpened (WindowEvent e)
    {}

    public void windowClosed (WindowEvent e)
    {}

    public void windowActivated (WindowEvent e)
    {}

    public void windowDeactivated (WindowEvent e)
    {}

    public void windowIconified (WindowEvent e)
    {}

    public void windowDeiconified (WindowEvent e)
    {}

    public void mouseReleased (MouseEvent e)
    {
        char RotuloDoBotao = ((Button)e.getComponent()).getLabel().charAt(0);

        switch (RotuloDoBotao)
        {
            case '0':
            case '1':
            case '2':
            case '3':
            case '4':
            case '5':
            case '6':
            case '7':
            case '8':
            case '9': this.TrateClickEmBotaoNumerico (RotuloDoBotao);
                      break;

            case '+':
            case '-':
            case '*':
            case '/': TrateClickEmBotaoDeOperacao (RotuloDoBotao);
                      break;

            case '=': TrateClickNoBotaoIgual ();
                      break;

            case 'C': TrateClickNoBotaoDeLimpar ();
        }
    }

    public void mousePressed (MouseEvent e)
    {}

    public void mouseClicked (MouseEvent e)
    {}

    public void mouseEntered (MouseEvent e)
    {}

    public void mouseExited (MouseEvent e)
    {}

    public void keyTyped (KeyEvent e)
    {
        if ((int)e.getKeyChar () == KeyEvent.VK_ENTER)
            e.setKeyChar ('=');
        else
            if ((int)e.getKeyChar () == KeyEvent.VK_ESCAPE)
                e.setKeyChar ('C');

        e.setKeyChar (Character.toUpperCase (e.getKeyChar ()));

        Date D = new Date ();

        for (int I = 0; I < Botao.length; I++)
            if (e.getKeyChar () == this.Botao [I].getLabel ().charAt (0))
            {
                this.Botao [I].dispatchEvent (new MouseEvent (
                                              this.Botao [I],
                                              MouseEvent.MOUSE_Released,
                                              D.getTime (),
                                              0, 0, 0, 1, false));
                break;
            }
    }

    public void keyPressed (KeyEvent e)
    {}

    public void keyReleased (KeyEvent e)
    {}
}