package ClienteSMTP;

import java.net.*;
import java.io.*;

public class ClienteSMTP
{
    private Socket         CanalDeComunicacao = null;
    private BufferedReader Entrada            = null;
    private PrintWriter    Saida              = null;

    public ClienteSMTP (String Servidor, int Porta) throws ExcecaoDeSMTP
    {
        try
        {
            CanalDeComunicacao = new Socket(Servidor, Porta);
        }
        catch (UnknownHostException E)
        {
            ExcecaoDeSMTP.indique (ExcecaoDeSMTP.SERVIDOR_DESCONHECIDO);
        }
        catch (IOException E)
        {
            ExcecaoDeSMTP.indique (ExcecaoDeSMTP.SERVIDOR_INCOMUNICAVEL);
        }

        try
        {
            Entrada = new BufferedReader (
                      new InputStreamReader (
                      CanalDeComunicacao.
                      getInputStream ()));
        }
        catch (IOException E)
        {
            ExcecaoDeSMTP.indique (ExcecaoDeSMTP.CANAL_DE_ENTRADA_INDISPONIVEL);
        }

        try
        {
            Saida = new PrintWriter (
                    new OutputStreamWriter (
                    CanalDeComunicacao.
                    getOutputStream()));
        }
        catch (IOException E)
        {
            ExcecaoDeSMTP.indique (ExcecaoDeSMTP.CANAL_DE_SAIDA_INDISPONIVEL);
        }
    }

    public void finalize () throws ExcecaoDeSMTP
    {
        try
        {
            Entrada.close();
            Entrada = null;

            Saida.close();
            Saida = null;

            CanalDeComunicacao.close();
            CanalDeComunicacao = null;
        }
        catch (IOException E)
        {
            ExcecaoDeSMTP.indique (ExcecaoDeSMTP.INSUCESSO_NA_DESCONEXAO);
        }
    }

    private int ObtenhaResposta () throws ExcecaoDeSMTP
    {
        int R = 0;

        try
        {
            R = Integer.parseInt(Entrada.readLine().substring(0,3));
        }
        catch (IOException E)
        {
            ExcecaoDeSMTP.indique (ExcecaoDeSMTP.INSUCESSO_NA_RECEPCAO);
        }

        return R;
    }

    public void EnvieMensagem (String NomeRemetente,
                               String E_mailRemetente,
                               String NomeDestinatario,
                               String E_mailDestinatario,
                               String Assunto,
                               String Mensagem)
                               throws ExcecaoDeSMTP
    {
            int Resposta;

            Resposta = this.ObtenhaResposta ();
            if (Resposta != 220)
                ExcecaoDeSMTP.indique (ExcecaoDeSMTP.SERVIDOR_INDISPONIVEL);

            String NomeDoMeuComputador = null;
            try
            {
                NomeDoMeuComputador = InetAddress.getLocalHost().getHostName();
            }
            catch (UnknownHostException E)
            {}

            Saida.println("HELO " + NomeDoMeuComputador);
            Saida.flush();

            Resposta = this.ObtenhaResposta ();
            if (Resposta != 250)
                ExcecaoDeSMTP.indique (ExcecaoDeSMTP.CLIENTE_RECUSADO);

            Saida.println("MAIL FROM: " + E_mailRemetente);
            Saida.flush();

            Resposta = this.ObtenhaResposta ();
            if (Resposta != 250)
                ExcecaoDeSMTP.indique (ExcecaoDeSMTP.REMETENTE_RECUSADO);

            Saida.println("RCPT TO: " + E_mailDestinatario);
            Saida.flush();

            Resposta = this.ObtenhaResposta (); // 250/251 DestinatarioRecusado
            if (Resposta != 250 && Resposta != 251)
                ExcecaoDeSMTP.indique (ExcecaoDeSMTP.DESTINATARIO_RECUSADO);

            Saida.println("DATA");
            Saida.flush();

            Resposta = this.ObtenhaResposta ();
            if (Resposta != 354)
                ExcecaoDeSMTP.indique (ExcecaoDeSMTP.SERVICO_INDISPONIVEL);

            Saida.println("FROM: " + NomeRemetente + " <" + E_mailRemetente + ">");
            Saida.flush();
            Saida.println("TO: " + NomeDestinatario + " <" + E_mailDestinatario + ">");
            Saida.flush();
            Saida.println("SUBJECT: " + Assunto);
            Saida.flush();
            Saida.println(Mensagem);
            Saida.flush();
            Saida.println(".");
            Saida.flush();
            Resposta = this.ObtenhaResposta ();
            if (Resposta != 250)
                ExcecaoDeSMTP.indique (ExcecaoDeSMTP.MENSAGEM_RECUSADA);

            Saida.println("QUIT");
            Saida.flush();
            Resposta = this.ObtenhaResposta ();
            if (Resposta != 221)
                ExcecaoDeSMTP.indique (ExcecaoDeSMTP.INSUCESSO_NA_DESPEDIDA);
    }
}